# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

#### Public Classes

* [`simp_ipa`](#simp_ipa): Placeholder class for now
* [`simp_ipa::client::install`](#simp_ipa--client--install): Run ipa-client-install on puppet clients

#### Private Classes

* `simp_ipa::client::packages`: Class to contain packages required for simp::simp_ipa::install

### Tasks

* [`join`](#join): Join nodes to an IPA domain
* [`leave`](#leave): Leave an IPA domain

## Classes

### <a name="simp_ipa"></a>`simp_ipa`

Placeholder class for now

### <a name="simp_ipa--client--install"></a>`simp_ipa::client::install`

Run ipa-client-install on puppet clients

* **Note** Not all parameters here are required. If the DNS is properly configured
on the host, nothing needs to be set besides $password. Be sure to read the
man page in ipa-client-install or the help for guidance

* **See also**
  * ipa-client-install(1)

#### Parameters

The following parameters are available in the `simp_ipa::client::install` class:

* [`ensure`](#-simp_ipa--client--install--ensure)
* [`ip_address`](#-simp_ipa--client--install--ip_address)
* [`hostname`](#-simp_ipa--client--install--hostname)
* [`password`](#-simp_ipa--client--install--password)
* [`principal`](#-simp_ipa--client--install--principal)
* [`server`](#-simp_ipa--client--install--server)
* [`domain`](#-simp_ipa--client--install--domain)
* [`realm`](#-simp_ipa--client--install--realm)
* [`no_ac`](#-simp_ipa--client--install--no_ac)
* [`install_options`](#-simp_ipa--client--install--install_options)
* [`ipa_client_ensure`](#-simp_ipa--client--install--ipa_client_ensure)
* [`admin_tools_ensure`](#-simp_ipa--client--install--admin_tools_ensure)
* [`ntp_server`](#-simp_ipa--client--install--ntp_server)

##### <a name="-simp_ipa--client--install--ensure"></a>`ensure`

Data type: `Enum['present','absent']`

'present' to add host to an IPA domain, 'absent' to remove

##### <a name="-simp_ipa--client--install--ip_address"></a>`ip_address`

Data type: `Optional[Array[Simplib::IP]]`

IP address of host being connected

Default value: `undef`

##### <a name="-simp_ipa--client--install--hostname"></a>`hostname`

Data type: `Optional[Simplib::Hostname]`

Hostname of the host being connected

Default value: `undef`

##### <a name="-simp_ipa--client--install--password"></a>`password`

Data type: `Optional[String]`

The password used for joining. The password can be of one of two types:
  * If $principal is set, this is the password relating to
    that administrative user
  * A one time password. A host-based one-time-password generated by
    ``ipa host-add`` or the GUI

Default value: `undef`

##### <a name="-simp_ipa--client--install--principal"></a>`principal`

Data type: `Optional[String]`

The administrative user krb5 principal that $password relates to, if the $password is not
a one time password

Default value: `undef`

##### <a name="-simp_ipa--client--install--server"></a>`server`

Data type: `Optional[Array[Simplib::Hostname]]`

IPA server to connect to

Default value: `undef`

##### <a name="-simp_ipa--client--install--domain"></a>`domain`

Data type: `Optional[Simplib::Hostname]`

IPA Domain

Default value: `undef`

##### <a name="-simp_ipa--client--install--realm"></a>`realm`

Data type: `Optional[String]`

IPA Realm

Default value: `undef`

##### <a name="-simp_ipa--client--install--no_ac"></a>`no_ac`

Data type: `Boolean`

Run without authconfig, defaults to true, appropriate on systems
using ``simp/pam``

Default value: `true`

##### <a name="-simp_ipa--client--install--install_options"></a>`install_options`

Data type: `Hash`

Hash of other options for the ``ipa-client-install`` command.  Any key
here that is also a class parameters will be overwritten with the value
of the corresponding class parameter. Also, if the option doesn't need a
value, (e.g., the `debug` option), just set the value of the setting to
Undef or nil in Hiera.

@see ``ipa-client-install --help``

Default value: `{}`

##### <a name="-simp_ipa--client--install--ipa_client_ensure"></a>`ipa_client_ensure`

Data type: `String`

Ensure attribute of the package resource managing the ``ipa-client`` package

Default value: `simplib::lookup('simp_options::package_ensure', { 'default_value' => 'installed' })`

##### <a name="-simp_ipa--client--install--admin_tools_ensure"></a>`admin_tools_ensure`

Data type: `String`

*Deprecated*: Was only applicable on EL6.

Default value: `simplib::lookup('simp_options::package_ensure', { 'default_value' => 'installed' })`

##### <a name="-simp_ipa--client--install--ntp_server"></a>`ntp_server`

Data type: `Optional[Array[Simplib::Host]]`



Default value: `undef`

## Tasks

### <a name="join"></a>`join`

Join nodes to an IPA domain

**Supports noop?** false

#### Parameters

##### `server`

Data type: `Optional[Simplib::Host]`

The IPA server to join to

##### `hostname`

Data type: `Optional[Simplib::Hostname]`

The hostname of the node to be set

##### `password`

Data type: `Optional[String]`

Password for authorization to the IPA server

##### `principal`

Data type: `Optional[String]`

Kerberos principal for authorization

##### `domain`

Data type: `Optional[Simplib::Hostname]`

IPA domain to join

##### `realm`

Data type: `Optional[String]`

IPA kerberos realm to join

##### `ip_address`

Data type: `Optional[Array[Simplib::IP]]`

IP address of the host, used in for creating DNS records in IPA

##### `options`

Data type: `Optional[String]`

Other command line options from `ipa-client-install`, specified as an argument string. For example: `--verbose`

### <a name="leave"></a>`leave`

Leave an IPA domain

**Supports noop?** false

#### Parameters

##### `options`

Data type: `Optional[String]`

Other command line options from `ipa-client-install`, specified as an arguments string. For example: `--verbose`

